`include "inc/router.svh"
`include "src/queue.sv"
`include "src/arbiter.sv"
`include "src/algorithm.sv"

module router (
    {0}
);

    wire[0:`PL-1] arbiter_to_algorithm;
    wire[0:`PL-1] algotihm_to_queue[0:`REN-1];
    wire availability_signals[0:`REN-1];
    wire[`REN_B-1:0] shift;
    wire send_data_flag;


    generate
        genvar i;
        for (i=0; i<`REN; i=i+1) begin : queues_initialiser
            queue queue_i (.clk(clk),
            .data_in(algotihm_to_queue[i]), .data_out(outputs[i]),
            .availability_signal(availability_signals[i]), .shift_signal(signals_in[i]));
        end
    endgenerate


    arbiter round_robin(.clk(clk),
    .input_(inputs), .output_data(arbiter_to_algorithm),
    .shift(shift)
    );

    {1}

    
endmodule
